<%@ page language="java" pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page import="java.io.PrintWriter, com.lombardisoftware.core.StringUtilities,
                 java.io.StringWriter, org.apache.commons.lang.StringEscapeUtils"%>
<%@ page import="com.lombardisoftware.core.TWUUID"%>
<%@ page import="com.lombardisoftware.core.util.MessageCache"%>
<%@ page import="com.lombardisoftware.core.util.PropertyMessageConfigurator"%>
<%@ page import="com.lombardisoftware.logger.WLELoggerConstants"%>
<%@ page import="com.lombardisoftware.core.config.TWConfiguration"%>
<%@ page import="com.lombardisoftware.core.config.server.DebugConfig"%>
<%@ page import="java.util.logging.Logger"%>
<%@ page import="java.util.logging.Level"%>				 
<%@ taglib uri="/lsw" prefix="lsw" %>
<%@ include file="/html/msgs-init.jsp" %>
<%@ page isErrorPage="true" %>

<%
    // APAR JR52721: Display a generic message and log into SystemOut
    final Logger logger = Logger.getLogger(WLELoggerConstants.PORTAL_LOGGER, WLELoggerConstants.WLE_PIIMESSAGE_FILE);
    String logErrorMessage;
	String displayErrorMessage;		// APAR JR55134: Restore original formatting of displayed error message, pre-JR52721, to prevent JavaScript errors
	String htmlErrorMessage; 		// APAR JR55134: Restore original formatting of HTML head and body
	
	// APAR JR54753: Display debug error message if displayDebugErrorMessages config flag is set to true (override JR52721 generic error message)
	DebugConfig debugConfig = TWConfiguration.getInstance().getServer().getDebug();
    if (debugConfig.isDisplayDebugErrorMessages()) {
        if (exception != null) {
		    logErrorMessage = exception.getMessage().toString();			
			displayErrorMessage = StringEscapeUtils.escapeJavaScript(exception.getMessage().toString()).replace("<","\\u003c");
			htmlErrorMessage = StringUtilities.xmlEncodeString(exception.getMessage().toString());
		} else {
            logErrorMessage = request.getAttribute("com.lombardisoftware.error.message").toString();			
			displayErrorMessage = StringEscapeUtils.escapeJavaScript(request.getAttribute("com.lombardisoftware.error.message").toString());
			htmlErrorMessage = logErrorMessage;
        }
	} else {
	    // Display generic error message
        final MessageCache cache = new MessageCache(new PropertyMessageConfigurator(WLELoggerConstants.WLE_PIIMESSAGE_FILE));

		// APAR JR55078: Generic message has single quotes in non-English languages, so encode the message for display
        logErrorMessage = cache.getMessage("EXPIMP_REMOTE_LOGIN_FAILED.useraction", com.lombardisoftware.client.LocaleUtils.getCurrentUserLocale(), null);
		displayErrorMessage = StringEscapeUtils.escapeJavaScript(logErrorMessage);
	    htmlErrorMessage = StringUtilities.xmlEncodeString(logErrorMessage);
	}
	
   	// Add UUID for correlation to SystemOut (even if displayDebugErrorMessages is set to true, correlator is still useful if there is also a stack trace logged by tm_error.jsp caller)
	String uuidSuffix = " (" + TWUUID.newUUID().toString() + ")";
	logErrorMessage += uuidSuffix;
	displayErrorMessage += uuidSuffix;
	htmlErrorMessage += uuidSuffix;
	
    // Log message to SystemOut
    logger.log(Level.SEVERE, logErrorMessage);
	
	// Log exception to SystemOut
    if(exception != null) {
		logger.log(Level.SEVERE, exception.getMessage());
    } else {
        logger.log(Level.SEVERE, request.getAttribute("com.lombardisoftware.error.message").toString());		
	}	
%>

<!--
<tw:xmlData>
<error>
<message>
<%= htmlErrorMessage %>
</message>
</error>
</tw:xmlData>
-->
<html>
<head>
<title><bean:message key="tm_error.title" /><%= htmlErrorMessage %></title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
</head>
<script language="JavaScript">

function doOnLoad() {
}

function showDetails() {
}

try {
    // Handle handshaking with social portal and task widget
    if ((!!(window.parent)) && (window != window.parent)) {
        var event = {
            "name": "onError",
            "parameters": [ '<%= displayErrorMessage %>']
		};
        // sending error message to the social portal
		// work item 131966
		var serializedEvent = JSON.stringify(event);
		try {
			window.parent.postMessage(serializedEvent, "*");
		} catch (e) {
			// postMessage() failed, use direct call onMessage instead with faked event. Container MUST be co-located
			console.log("iframe postMessage() failed, call onMessage() directly - event=", serializedEvent);
			if (!!window.parent.onMessage && typeof window.parent.onMessage === 'function') {				
				window.parent.onMessage({origin: window.location.protocol + "//" + window.location.host,
										data: serializedEvent, 
										source: window});
			} else {
				console.log("onMessage() does not exist");				
			}
		}		
    }
} catch (e) {
}
</script>
<LINK REL="stylesheet" HREF="<lsw:ImagePrefix />html/common/tw.css" TYPE="text/css">
<body class="folders" style="margin-top:35px;" onLoad="doOnLoad()">
<table width="100%" cellpadding="0" cellspacing="0" border="0">
<tr><td class="cstitle">&nbsp;<bean:message key="tm_error.error" /></td></tr>
</table>
<table cellpadding="4" cellspacing="0" border="0" width="100%" style="border:solid black 1">
<tr>
<td><div class="errormsg" align="left"><%= htmlErrorMessage %></div></td>
</tr>
</table>
</body>
</html>
